unsigned __int16 FP_COMP_S(unsigned char *cp,unsigned char Reg)
{
	*(cp++)=0xd8;		
	*(cp++)=0x9d;		
	unsigned __int32 tmp=Reg*4+1792;
	memcpy(cp,&tmp,4);
	return(6);
}

unsigned __int16 FP_COMP_D(unsigned char *cp,unsigned char Reg)
{
	*(cp++)=0xdc;		
	*(cp++)=0x9d;		
	unsigned __int32 tmp=Reg*4+1792;
	memcpy(cp,&tmp,4);
	return(6);
}

unsigned __int16 FP_STORE_STATUS(unsigned char *cp)
{
	*(cp++)=0x9b;		
	*(cp++)=0xdf;		
	*(cp++)=0xe0;		
	return(3);
}

unsigned __int16 FP_SET_ROUNDCONTROL(unsigned char *cp,unsigned __int32 Mode)
{
	*(cp++)=0x9b;		// wait
	*(cp++)=0xd9;		// fldcw
    *(cp++)=0xad;
	memcpy(cp,&Mode,4);
	cp+=4;
	*(cp++)=0x9b;		// wait

	return(8);
}

unsigned __int16 FP_ROUND(unsigned char *cp)
{
	*(cp++)=0xd9;
    *(cp++)=0xfc;
	return(2);
}

unsigned __int16 FP_LOAD_S_REG(unsigned char *cp,unsigned char Reg)
{
	*(cp++)=0xd9;
    *(cp++)=0x85;
	unsigned __int32 tmp=Reg*4+1792;
	memcpy(cp,&tmp,4);
	return(6);
}

unsigned __int16 FP_LOAD_W_REG(unsigned char *cp,unsigned char Reg)
{
	*(cp++)=0xdb;
    *(cp++)=0x85;
	unsigned __int32 tmp=Reg*4+1792;
	memcpy(cp,&tmp,4);
	return(6);
}

unsigned __int16 FP_LOAD_L_REG(unsigned char *cp,unsigned char Reg)
{
	*(cp++)=0xdf;
    *(cp++)=0x85;
	unsigned __int32 tmp=Reg*4+1792;
	memcpy(cp,&tmp,4);
	return(6);
}


unsigned __int16 FP_LOAD_D_REG(unsigned char *cp,unsigned char Reg)
{
	*(cp++)=0xdd;
    *(cp++)=0x85;
	unsigned __int32 tmp=Reg*4+1792;
	memcpy(cp,&tmp,4);
	return(6);
}

unsigned __int16 FP_STORE_S_REG(unsigned char *cp,unsigned char Reg)
{
	*(cp++)=0xd9;
    *(cp++)=0x9d;
	unsigned __int32 tmp=Reg*4+1792;
	memcpy(cp,&tmp,4);
	return(6);
}

unsigned __int16 FP_STORE_D_REG(unsigned char *cp,unsigned char Reg)
{
	*(cp++)=0xdd;
    *(cp++)=0x9d;
	unsigned __int32 tmp=Reg*4+1792;
	memcpy(cp,&tmp,4);
	return(6);
}

unsigned __int16 FP_STORE_L_REG(unsigned char *cp,unsigned char Reg)
{
	*(cp++)=0xdf;
    *(cp++)=0xbd;
	unsigned __int32 tmp=Reg*4+1792;
	memcpy(cp,&tmp,4);
	return(6);
}

unsigned __int16 FP_STORE_W_REG(unsigned char *cp,unsigned char Reg)
{
	*(cp++)=0xdb;
    *(cp++)=0x9d;
	unsigned __int32 tmp=Reg*4+1792;
	memcpy(cp,&tmp,4);
	return(6);
}

unsigned __int16 FP_ADD(unsigned char *cp)
{
	*(cp++)=0xde;
	*(cp++)=0xc1;
	return(2);
}


unsigned __int16 FP_SUB(unsigned char *cp)
{
	*(cp++)=0xde;
	*(cp++)=0xe9;
	return(2);
}


unsigned __int16 FP_MUL(unsigned char *cp)
{
	*(cp++)=0xde;
	*(cp++)=0xc9;
	return(2);
}


unsigned __int16 FP_DIV(unsigned char *cp)
{
	*(cp++)=0xde;
	*(cp++)=0xf9;
	return(2);
}


unsigned __int16 FP_SQRT(unsigned char *cp)
{
	*(cp++)=0xd9;
	*(cp++)=0xfa;
	return(2);
}


unsigned __int16 FP_ABS(unsigned char *cp)
{
	*(cp++)=0xd9;
	*(cp++)=0xe1;
	return(2);
}


unsigned __int16 FP_NEG(unsigned char *cp)
{
	*(cp++)=0xd9;
	*(cp++)=0xe0;
	return(2);
}


unsigned __int16 dynaOpFPAddS(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
//	l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_LOAD_S_REG(cp+l,op2);
	l+=FP_ADD(cp+l);
	l+=FP_STORE_S_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPAddD(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
//	l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_LOAD_D_REG(cp+l,op2);
	l+=FP_ADD(cp+l);
	l+=FP_STORE_D_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPSubS(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
//	l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_LOAD_S_REG(cp+l,op2);
	l+=FP_SUB(cp+l);
	l+=FP_STORE_S_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPSubD(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
//	l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_LOAD_D_REG(cp+l,op2);
	l+=FP_SUB(cp+l);
	l+=FP_STORE_D_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPMulS(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_LOAD_S_REG(cp+l,op2);
	l+=FP_MUL(cp+l);
	l+=FP_STORE_S_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPMulD(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_LOAD_D_REG(cp+l,op2);
	l+=FP_MUL(cp+l);
	l+=FP_STORE_D_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPDivS(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_LOAD_S_REG(cp+l,op2);
	l+=FP_DIV(cp+l);
	l+=FP_STORE_S_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPDivD(unsigned char *cp,unsigned char op0,unsigned char op1,unsigned char op2)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_LOAD_D_REG(cp+l,op2);
	l+=FP_DIV(cp+l);
	l+=FP_STORE_D_REG(cp+l,op0);
	return(l);
}


unsigned __int16 dynaOpFPSqrtS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_SQRT(cp+l);
	l+=FP_STORE_S_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPSqrtD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_SQRT(cp+l);
	l+=FP_STORE_D_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPAbsS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_ABS(cp+l);
	l+=FP_STORE_S_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPAbsD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_ABS(cp+l);
	l+=FP_STORE_D_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPNegS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_NEG(cp+l);
	l+=FP_STORE_S_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPNegD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	// DstReg=(float)op1+(float)op2;
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_NEG(cp+l);
	l+=FP_STORE_D_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPCvtSFromD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_STORE_S_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPCvtSFromW(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_W_REG(cp+l,op1);
	l+=FP_STORE_S_REG(cp+l,op0);
	return(l);
}


unsigned __int16 dynaOpFPCvtSFromL(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_L_REG(cp+l,op1);
	l+=FP_STORE_S_REG(cp+l,op0);
	return(l);
}


unsigned __int16 dynaOpFPCvtDFromS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_STORE_D_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPCvtDFromW(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_W_REG(cp+l,op1);
	l+=FP_STORE_D_REG(cp+l,op0);
	return(l);
}


unsigned __int16 dynaOpFPCvtDFromL(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_L_REG(cp+l,op1);
	l+=FP_STORE_D_REG(cp+l,op0);
	return(l);
}



unsigned __int16 dynaOpFPCvtWFromS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_STORE_W_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPCvtWFromD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_STORE_W_REG(cp+l,op0);
	return(l);
}


unsigned __int16 dynaOpFPCvtWFromL(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_L_REG(cp+l,op1);
	l+=FP_STORE_W_REG(cp+l,op0);
	return(l);
}


unsigned __int16 dynaOpFPCvtLFromS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_STORE_L_REG(cp+l,op0);
	return(l);
}

unsigned __int16 dynaOpFPCvtLFromD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_STORE_L_REG(cp+l,op0);
	return(l);
}


unsigned __int16 dynaOpFPCvtLFromW(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_W_REG(cp+l,op1);
	l+=FP_STORE_L_REG(cp+l,op0);
	return(l);
}


unsigned __int16 dynaOpFPRoundLS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_ROUND(cp+l);
	l+=FP_STORE_L_REG(cp+l,op0);
	return(l);
}


unsigned __int16 dynaOpFPRoundLD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_ROUND(cp+l);
	l+=FP_STORE_L_REG(cp+l,op0);
	return(l);
}


unsigned __int16 dynaOpFPRoundWS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_ROUND(cp+l);
	l+=FP_STORE_W_REG(cp+l,op0);
	return(l);
}


unsigned __int16 dynaOpFPRoundWD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_ROUND(cp+l);
	l+=FP_STORE_W_REG(cp+l,op0);
	return(l);
}


unsigned __int16 dynaOpFPTruncWS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_SET_ROUNDCONTROL(cp+l,TRUNC);
	l+=FP_STORE_W_REG(cp+l,op0);
	l+=FP_SET_ROUNDCONTROL(cp+l,ROUND);
	return(l);
}

unsigned __int16 dynaOpFPTruncWD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_SET_ROUNDCONTROL(cp+l,TRUNC);
	l+=FP_STORE_W_REG(cp+l,op0);
	l+=FP_SET_ROUNDCONTROL(cp+l,ROUND);
	return(l);
}

unsigned __int16 dynaOpFPTruncLS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_SET_ROUNDCONTROL(cp+l,TRUNC);
	l+=FP_STORE_L_REG(cp+l,op0);
	l+=FP_SET_ROUNDCONTROL(cp+l,ROUND);
	return(l);
}

unsigned __int16 dynaOpFPTruncLD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_SET_ROUNDCONTROL(cp+l,TRUNC);
	l+=FP_STORE_L_REG(cp+l,op0);
	l+=FP_SET_ROUNDCONTROL(cp+l,ROUND);
	return(l);
}

unsigned __int16 dynaOpFPCeilLS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_SET_ROUNDCONTROL(cp+l,CEIL);
	l+=FP_STORE_L_REG(cp+l,op0);
	l+=FP_SET_ROUNDCONTROL(cp+l,ROUND);
	return(l);
}

unsigned __int16 dynaOpFPCeilLD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_SET_ROUNDCONTROL(cp+l,CEIL);
	l+=FP_STORE_L_REG(cp+l,op0);
	l+=FP_SET_ROUNDCONTROL(cp+l,ROUND);
	return(l);
}

unsigned __int16 dynaOpFPCeilWS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_SET_ROUNDCONTROL(cp+l,CEIL);
	l+=FP_STORE_W_REG(cp+l,op0);
	l+=FP_SET_ROUNDCONTROL(cp+l,ROUND);
	return(l);
}

unsigned __int16 dynaOpFPCeilWD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_SET_ROUNDCONTROL(cp+l,CEIL);
	l+=FP_STORE_W_REG(cp+l,op0);
	l+=FP_SET_ROUNDCONTROL(cp+l,ROUND);
	return(l);
}

unsigned __int16 dynaOpFPFloorWD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_SET_ROUNDCONTROL(cp+l,FLOOR);
	l+=FP_STORE_W_REG(cp+l,op0);
	l+=FP_SET_ROUNDCONTROL(cp+l,ROUND);
	return(l);
}

unsigned __int16 dynaOpFPFloorWS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_SET_ROUNDCONTROL(cp+l,FLOOR);
	l+=FP_STORE_W_REG(cp+l,op0);
	l+=FP_SET_ROUNDCONTROL(cp+l,ROUND);
	return(l);
}

unsigned __int16 dynaOpFPFloorLD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_SET_ROUNDCONTROL(cp+l,FLOOR);
	l+=FP_STORE_L_REG(cp+l,op0);
	l+=FP_SET_ROUNDCONTROL(cp+l,ROUND);
	return(l);
}

unsigned __int16 dynaOpFPFloorLS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);
	//l+=STORE_REG(cp+l,242,PC_PTR);
	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_SET_ROUNDCONTROL(cp+l,FLOOR);
	l+=FP_STORE_L_REG(cp+l,op0);
	l+=FP_SET_ROUNDCONTROL(cp+l,ROUND);
	return(l);
}

unsigned __int16 dynaOpFPMovS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);

	unsigned __int32 DstOff,SrcOff;
	DstOff=op0*4+1792;
	SrcOff=op1*4+1792;
	l+=MEM_TO_MEM_DWORD(cp+l,DstOff,SrcOff);
	return(l);
}

unsigned __int16 dynaOpFPMovD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);

	unsigned __int32 DstOff,SrcOff;
	DstOff=op0*4+1792;
	SrcOff=op1*4+1792;
	l+=MEM_TO_MEM_QWORD(cp+l,DstOff,SrcOff);
	return(l);
}

unsigned __int16 dynaOpFPEqualS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;

	l+=INC_PC_COUNTER(cp+l);


	l+=PUSH_REGISTER(cp+l,NATIVE_0);
	l+=FP_LOAD_S_REG(cp+l,op0);
	l+=FP_COMP_S(cp+l,op1);
	l+=FP_STORE_STATUS(cp+l);
	l+=SLL_REG_IMM(cp+l,NATIVE_0,9);
	l+=AND_REG_IMM(cp+l,NATIVE_0,0x00800000);
	unsigned __int32 offset=CCR1+8*31;
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,offset);
	l+=POP_REGISTER(cp+l,NATIVE_0);

	return(l);
}

unsigned __int16 dynaOpFPLessThanS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);

	l+=FP_LOAD_S_REG(cp+l,op0);
	l+=FP_COMP_S(cp+l,op1);
	l+=FP_STORE_STATUS(cp+l);
	l+=SLL_REG_IMM(cp+l,NATIVE_0,15);
	unsigned __int32 offset=CCR1+8*31;
	l+=AND_REG_IMM(cp+l,NATIVE_0,0x00800000);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,offset);

	return(l);
}

unsigned __int16 dynaOpFPLessThanEqualS(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);

	l+=FP_LOAD_S_REG(cp+l,op1);
	l+=FP_COMP_S(cp+l,op0);
	l+=FP_STORE_STATUS(cp+l);
	l+=SLL_REG_IMM(cp+l,NATIVE_0,15);
	unsigned __int32 offset=CCR1+8*31;
	l+=AND_REG_IMM(cp+l,NATIVE_0,0x00800000);
	l+=NOT_REG(cp+l,NATIVE_0);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,offset);

	return(l);
}

unsigned __int16 dynaOpFPEqualD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);

	l+=FP_LOAD_D_REG(cp+l,op0);
	l+=FP_COMP_D(cp+l,op1);
	l+=FP_STORE_STATUS(cp+l);
	l+=ZERO_EXTEND_REG(cp+l,NATIVE_0);
	l+=SLL_REG_IMM(cp+l,NATIVE_0,9);
	l+=AND_REG_IMM(cp+l,NATIVE_0,0x00800000);
	unsigned __int32 offset=CCR1+8*31;
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,offset);

	return(l);
}

unsigned __int16 dynaOpFPLessThanD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);

	l+=FP_LOAD_D_REG(cp+l,op0);
	l+=FP_COMP_D(cp+l,op1);
	l+=FP_STORE_STATUS(cp+l);
	l+=ZERO_EXTEND_REG(cp+l,NATIVE_0);
	l+=SLL_REG_IMM(cp+l,NATIVE_0,15);
	unsigned __int32 offset=CCR1+8*31;
	l+=AND_REG_IMM(cp+l,NATIVE_0,0x00800000);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,offset);

	return(l);
}

unsigned __int16 dynaOpFPLessThanEqualD(unsigned char *cp,unsigned char op0,unsigned char op1)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);

	l+=FP_LOAD_D_REG(cp+l,op1);
	l+=FP_COMP_D(cp+l,op0);
	l+=FP_STORE_STATUS(cp+l);
	l+=ZERO_EXTEND_REG(cp+l,NATIVE_0);
	l+=SLL_REG_IMM(cp+l,NATIVE_0,15);
	unsigned __int32 offset=CCR1+8*31;
	l+=AND_REG_IMM(cp+l,NATIVE_0,0x00800000);
	l+=NOT_REG(cp+l,NATIVE_0);
	l+=STORE_REG_TO_RBANK(cp+l,NATIVE_0,offset);

	return(l);
}

unsigned __int16 dynaOpFPSetFalse(unsigned char *cp)
{
	unsigned __int16 l=0;
	l+=INC_PC_COUNTER(cp);

	unsigned __int32 offset=CCR1+8*31;
	l+=AND_RBANK_WITH_IMM(cp+l,~0x00800000,offset);

	return(l);
}