#ifndef __3DMATH

#define __3DMATH

#include <windows.h>
#include <math.h>

typedef float MATRIX3[9];
typedef float MATRIX4[16];
typedef float VFLOAT;
typedef	float VECTOR[4];

extern void PrintMatrix4(MATRIX4 Matrix);
extern void PrintVector(VECTOR vec);
extern void PrintFloat(float f);
extern void m4_submat( MATRIX4 mr, MATRIX3 mb, int i, int j );
extern VFLOAT m4_det( MATRIX4 mr );
extern int m4_inverse( MATRIX4 mr, MATRIX4 ma );
extern int m3_inverse( MATRIX4 mr, MATRIX4 ma );
extern VFLOAT m3_det( MATRIX3 mat );
extern void TranformVector(float *src, float *dst, MATRIX4 mat);
extern float DotProduct(float *v1, float *v2);
extern void NormalizeVector(float *v);
extern BOOL compare_matrix4(MATRIX4 m1, MATRIX4 m2);
#endif